local ADDON_NAME, addon = ...
LibStub("AceAddon-3.0"):NewAddon(addon, ADDON_NAME)

--local L = LibStub("AceLocale-3.0"):GetLocale(ADDON_NAME)
addon.LSM = LibStub("LibSharedMedia-3.0")

local defaults = {
	profile = {
		oocfade = true,
		oocalpha = 0.2,
		eclipsebar = {
			from = "CENTER",
			parent = "UIParent",
			to = "CENTER",
			posx = 0,
			posy = -120,
			width = 300,
			height = 20,
			texture = "Blizzard",
			solarcolor = { r = 1, g = 0.69, b = 0.04 },
			lunarcolor = { r = 0.04, g = 0.39, b = 1 },
			showtextures = true,
			timer = {
				from = "CENTER",
				to = "CENTER",
				posx = 4,
				posy = 0,
				font = "Friz Quadrata TT",
				fontsize = 24,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE",
				show = true	  
			},
			value = {
				from = "CENTER",
				to = "CENTER",
				posx = 4,
				posy = 0,
				font = "Friz Quadrata TT",
				fontsize = 24,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE",
				show = false
			},
			backdrop = {
				bgFile = "Blizzard Tooltip",
				edgeFile = "Blizzard Dialog",
				tile = true,
				tileSize = 32,
				edgeSize = 16,
				inset = 5,
				offset = 5,
				color = { r = 0, g = 0, b = 0, a = 1 },
				bordercolor = { r = 0.5, g = 0.5, b = 0.5, a = 1 }
			}
		},
		alignmentbar = {
			enable = true,
			from = "TOPLEFT",
			parent = "EclipseBar",
			to = "BOTTOMLEFT",
			posx = 0,
			posy = -10,
			width = 147,
			height = 10,
			texture = "Blizzard",
			barcolor = { r = 0.76, g = 0.42, b = 0 },
			text = {
				font = "Friz Quadrata TT",
				fontsize = 12,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE"
			},
			backdrop = {
				bgFile = "Blizzard Tooltip",
				edgeFile = "Blizzard Dialog",
				tile = true,
				tileSize = 32,
				edgeSize = 16,
				inset = 5,
				offset = 5,
				color = { r = 0, g = 0, b = 0, a = 1 },
				bordercolor = { r = 0.5, g = 0.5, b = 0.5, a = 1 }
			}
		},
		incarnationbar = {
			enable = true,
			from = "TOPRIGHT",
			parent = "EclipseBar",
			to = "BOTTOMRIGHT",
			posx = 0,
			posy = -10,
			width = 147,
			height = 10,
			texture = "Blizzard",
			barcolor = { r = 0.76, g = 0.42, b = 0 },
			text = {
				font = "Friz Quadrata TT",
				fontsize = 12,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE"
			},
			backdrop = {
				bgFile = "Blizzard Tooltip",
				edgeFile = "Blizzard Dialog",
				tile = true,
				tileSize = 32,
				edgeSize = 16,
				inset = 5,
				offset = 5,
				color = { r = 0, g = 0, b = 0, a = 1 },
				bordercolor = { r = 0.5, g = 0.5, b = 0.5, a = 1 }
			}
		},
		starfallbar = {
			enable = true,
			from = "BOTTOM",
			parent = "EclipseBar",
			to = "TOP",
			posx = 0,
			posy = 2,
			width = 300,
			height = 10,
			texture = "Blizzard",
			solarcolor = { r = 0.76, g = 0.42, b = 0 },
			lunarcolor = { r = 0, g = 0.35, b = 0.76 },
			text = {
				font = "Friz Quadrata TT",
				fontsize = 12,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE"
			},
			backdrop = {
				bgFile = "Blizzard Tooltip",
				edgeFile = "Blizzard Dialog",
				tile = true,
				tileSize = 32,
				edgeSize = 16,
				inset = 5,
				offset = 5,
				color = { r = 0, g = 0, b = 0, a = 1 },
				bordercolor = { r = 0.5, g = 0.5, b = 0.5, a = 1 }
			}
		},
		starsurge = {
			enable = true,
			from = "BOTTOM",
			to = "TOP",
			posx = 0,
			posy = 20,
			size = 25
		},
		icons = {
			solarempowerment = {
				enable = true,
				from = "BOTTOMLEFT",
				to = "TOPLEFT",
				posx = 0,
				posy = 20,
				size = 32,
				font = "Friz Quadrata TT",
				fontsize = 16,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE"
			},
			lunarempowerment = {
				enable = true,
				from = "BOTTOMLEFT",
				to = "TOPLEFT",
				posx = 36,
				posy = 20,
				size = 32,
				font = "Friz Quadrata TT",
				fontsize = 16,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE"
			},
			forceofnature = {
				enable = true,
				from = "BOTTOMLEFT",
				to = "TOPLEFT",
				posx = 72,
				posy = 20,
				size = 32,
				font = "Friz Quadrata TT",
				fontsize = 16,
				fontcolor = { r = 1, g = 1, b = 1 },
				outline = "OUTLINE"
			},
			moonfire = {
				enable = true,
				from = "BOTTOMRIGHT",
				to = "TOPRIGHT",
				posx = 0,
				posy = 20,
				size = 32
			},
			sunfire = {
				enable = true,
				from = "BOTTOMRIGHT",
				to = "TOPRIGHT",
				posx = -36,
				posy = 20,
				size = 32
			},
			stellarflare = {
				enable = true,
				from = "BOTTOMRIGHT",
				to = "TOPRIGHT",
				posx = -72,
				posy = 20,
				size = 32
			}
		}
	}
}

local barData = {
	maxValues = {
		eclipsebar = 100,
		alignmentbar = 15,
		incarnationbar = 30,
		starfallbar = 10
	},
	names = {
		alignmentbar = "CA",
		incarnationbar = "INC",
		starfallbar = "Starfall"
	},
	spells = {
		select(1,GetSpellInfo(112071)),		-- Alignment
		select(1,GetSpellInfo(102560)),		-- Incarnation
		select(1,GetSpellInfo(48505)),		-- Starfall
		select(1,GetSpellInfo(155592)),		-- Sunfall
		select(1,GetSpellInfo(164545)),		-- Solar Empowerment
		select(1,GetSpellInfo(164547)),		-- Lunar Empowerment
		select(1,GetSpellInfo(33831)),		-- Force of Nature
		select(1,GetSpellInfo(8921)),		-- Moonfire
		select(1,GetSpellInfo(93402)),		-- Sunfire
		select(1,GetSpellInfo(152221)),		-- Stellar Flare
		select(1,GetSpellInfo(78674)),		-- Starsurge
		select(1,GetSpellInfo(5176)),		-- Wrath
		select(1,GetSpellInfo(2912)),		-- Starfire
	},
	icons = {
		solarempowerment = "spell_nature_wrathv2",
		lunarempowerment = "spell_arcane_starfire",
		forceofnature = "ability_druid_forceofnature",
		moonfire = "spell_nature_starfall",
		sunfire = "ability_mage_firestarter",
		stellarflare = "ability_druid_stellarflare",
	}
}

local hasEuphoria, hasBoP = false, false

-------------------------------------------------------------------------------
-- ADDON LOADING
-------------------------------------------------------------------------------

function addon:OnInitialize()

	if DayNightCycleDB == nil then
		if DNC_Config ~= nil then
			local oldDB = {}
			oldDB.profile = DNC_Config
			self.db = LibStub("AceDB-3.0"):New("DayNightCycleDB", defaults, true)
			DayNightCycleDB.profiles = {}
			DayNightCycleDB.profiles.DayNightCycle = DNC_Config
			
			self.db:SetProfile("DayNightCycle")
			
			if self.db.profile.alignmentbar.parent == "DNC_Container" then
				self.db.profile.alignmentbar.parent = "EclipseBar"
			end
			if self.db.profile.incarnationbar.parent == "DNC_Container" then
				self.db.profile.incarnationbar.parent = "EclipseBar"
			end
			if self.db.profile.starfallbar.parent == "DNC_Container" then
				self.db.profile.starfallbar.parent = "EclipseBar"
			end
			
			DNC_Config = true
		else
			self.db = LibStub("AceDB-3.0"):New("DayNightCycleDB", defaults, true)
		end
	else
		local pName, pRealm = UnitName("player"), GetRealmName("player")
		local pKey = pName.." - "..pRealm
		local old = false
		
		if DayNightCycleDB.profileKeys[pKey] == nil and DNC_Config == true then
			old = true
		end
		
		self.db = LibStub("AceDB-3.0"):New("DayNightCycleDB", defaults, true)
		
		if old == true then
			self.db:SetProfile("DayNightCycle")
		end
	end
	
	self.db.RegisterCallback(self, "OnProfileChanged", "UpdateAll")
	self.db.RegisterCallback(self, "OnProfileCopied", "UpdateAll")
	self.db.RegisterCallback(self, "OnProfileReset", "UpdateAll")
end

function addon:OnEnable()
	self.EclipseBar = self:CreateStatusBar("eclipsebar")
	if self.db.profile.oocfade == true then
		self.EclipseBar:SetAlpha(self.db.profile.oocalpha)
	end

	self.AlignmentBar = self:CreateStatusBar("alignmentbar")
	self.IncarnationBar = self:CreateStatusBar("incarnationbar")
	self.StarfallBar = self:CreateStatusBar("starfallbar")

	self.Starsurge = self:CreateStarsurgeCharges(self.EclipseBar)
	if self.db.profile.starsurge.enable == false then self.Starsurge:Hide() end

	self.SolarEmpowerment = self:CreateAuraIcon("solarempowerment", self.EclipseBar)
	self.LunarEmpowerment = self:CreateAuraIcon("lunarempowerment", self.EclipseBar)
	self.ForceOfNature = self:CreateAuraIcon("forceofnature", self.EclipseBar)

	self.Moonfire = self:CreateAuraIcon("moonfire", self.EclipseBar)
	self.Sunfire = self:CreateAuraIcon("sunfire", self.EclipseBar)
	self.StellarFlare = self:CreateAuraIcon("stellarflare", self.EclipseBar)
	
    self:CheckSpecialization()
	
	EclipseBarFrame:Hide()
	EclipseBarFrame.Show = function() end
    self.EclipseBar:RegisterEvent("PLAYER_TALENT_UPDATE")
	self.EclipseBar:RegisterEvent("PLAYER_TARGET_CHANGED")

	self.EclipseBar:SetScript("OnEvent", function(self, event, arg1, ...)
		if event == "PLAYER_TALENT_UPDATE" then
			addon:CheckSpecialization()
		elseif event == "PLAYER_REGEN_ENABLED" then
			UIFrameFadeOut(addon.EclipseBar, 1, 1, addon.db.profile.oocalpha)
		elseif event == "PLAYER_REGEN_DISABLED" then
			UIFrameFadeIn(addon.EclipseBar, 1, addon.db.profile.oocalpha, 1)
		elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
			addon:checkCombatLog(...)
		elseif event == "PLAYER_TARGET_CHANGED" then
			addon:CheckDebuffs()
		end
	end)
end

-------------------------------------------------------------------------------
-- FRAME CREATION FUNCTIONS
-------------------------------------------------------------------------------

-- CreateStatusBar()
function addon:CreateStatusBar(barType)
	local cfg = self.db.profile[barType]
	local parent
	
	if barType == "eclipsebar" then
		parent = _G[cfg.parent]
	else
		parent = self[cfg.parent]
	end
	
	local Bar = CreateFrame("StatusBar", nil, parent)
	Bar:SetPoint(cfg.from, parent, cfg.to, cfg.posx, cfg.posy)
	Bar:SetWidth(cfg.width)
	Bar:SetHeight(cfg.height)
	Bar:SetMinMaxValues(0, barData.maxValues[barType])
	Bar:SetStatusBarTexture(self.LSM:Fetch("statusbar", cfg.texture))
	Bar:GetStatusBarTexture():SetHorizTile(false)
	Bar:GetStatusBarTexture():SetVertTile(false)
	if barType == "eclipsebar" or barType == "starfallbar" then
		Bar:SetStatusBarColor(cfg.solarcolor.r, cfg.solarcolor.g, cfg.solarcolor.b)
	else
		Bar:SetStatusBarColor(cfg.barcolor.r, cfg.barcolor.g, cfg.barcolor.b)
	end
	Bar:SetFrameLevel(2)
	
	Bar.Background = CreateFrame("Frame", nil, Bar)
	Bar.Background:SetPoint("TOPLEFT", Bar, "TOPLEFT", -cfg.backdrop.offset, cfg.backdrop.offset)
	Bar.Background:SetPoint("BOTTOMRIGHT", Bar, "BOTTOMRIGHT", cfg.backdrop.offset, -cfg.backdrop.offset)
	Bar.Background:SetBackdrop({
		bgFile = self.LSM:Fetch("background", cfg.backdrop.bgFile),
		edgeFile = self.LSM:Fetch("border", cfg.backdrop.edgeFile),
		tile = cfg.backdrop.tile,
		tileSize = cfg.backdrop.tileSize,
		edgeSize = cfg.backdrop.edgeSize,
		insets = {
			left = cfg.backdrop.inset,
			right = cfg.backdrop.inset,
			top = cfg.backdrop.inset,
			bottom = cfg.backdrop.inset
		}
	})
	Bar.Background:SetBackdropColor(cfg.backdrop.color.r, cfg.backdrop.color.g, cfg.backdrop.color.b, cfg.backdrop.color.a)
	Bar.Background:SetBackdropBorderColor(cfg.backdrop.bordercolor.r, cfg.backdrop.bordercolor.g, cfg.backdrop.bordercolor.b, cfg.backdrop.bordercolor.a)
	Bar.Background:SetFrameLevel(1)

	if barType == "eclipsebar" then
		Bar.Timer = Bar:CreateFontString(nil, "OVERLAY")
		Bar.Timer:SetPoint(cfg.timer.from, Bar, cfg.timer.to, cfg.timer.posx, cfg.timer.posy)
		Bar.Timer:SetFont(self.LSM:Fetch("font",cfg.timer.font), cfg.timer.fontsize, cfg.timer.outline)
		Bar.Timer:SetJustifyH("LEFT")
		Bar.Timer:SetTextColor(cfg.timer.fontcolor.r, cfg.timer.fontcolor.g, cfg.timer.fontcolor.b)
		Bar.Timer:SetText("0")
		if cfg.timer.show == false then Bar.Timer:Hide() end

		Bar.Value = Bar:CreateFontString(nil, "OVERLAY")
		Bar.Value:SetPoint(cfg.value.from, Bar, cfg.value.to, cfg.value.posx, cfg.value.posy)
		Bar.Value:SetFont(self.LSM:Fetch("font", cfg.value.font), cfg.value.fontsize, cfg.value.outline)
		Bar.Value:SetJustifyH("LEFT")
		Bar.Value:SetTextColor(cfg.value.fontcolor.r, cfg.value.fontcolor.g, cfg.value.fontcolor.b)
		Bar.Value:SetText("0")
		if cfg.value.show == false then Bar.Value:Hide() end
	
		-- Eclipse Overlay Textures
		Bar.EclipseLeft = Bar:CreateTexture(nil, "LOW")
		Bar.EclipseLeft:SetPoint("RIGHT", Bar, "LEFT", 12, 0)
		Bar.EclipseLeft:SetTexture("Textures\\SpellActivationOverlays\\Eclipse_Sun")
		Bar.EclipseLeft:SetVertexColor(cfg.solarcolor.r, cfg.solarcolor.g, cfg.solarcolor.b)
		Bar.EclipseLeft:SetWidth(60)
		Bar.EclipseLeft:SetHeight(100)
		Bar.EclipseLeft:SetBlendMode("BLEND")
		if cfg.showtextures == false then Bar.EclipseLeft:Hide() end
		
		Bar.EclipseRight = Bar:CreateTexture(nil, "LOW")
		Bar.EclipseRight:SetPoint("LEFT", Bar, "RIGHT", -12, 0)
		Bar.EclipseRight:SetTexture("Textures\\SpellActivationOverlays\\Eclipse_Sun")
		Bar.EclipseRight:SetTexCoord(1, 0, 0, 1)
		Bar.EclipseRight:SetVertexColor(cfg.solarcolor.r, cfg.solarcolor.g, cfg.solarcolor.b)
		Bar.EclipseRight:SetWidth(60)
		Bar.EclipseRight:SetHeight(100)
		Bar.EclipseRight:SetBlendMode("BLEND")
		if cfg.showtextures == false then Bar.EclipseRight:Hide() end
	else
		Bar.Name = Bar:CreateFontString(nil, "OVERLAY")
		Bar.Name:SetPoint("LEFT", Bar, "LEFT", 25, 0)
		Bar.Name:SetFont(self.LSM:Fetch("font", cfg.text.font), cfg.text.fontsize, cfg.text.outline)
		Bar.Name:SetJustifyH("LEFT")
		Bar.Name:SetTextColor(cfg.text.fontcolor.r, cfg.text.fontcolor.g, cfg.text.fontcolor.b)
		Bar.Name:SetText(barData.names[barType])
		
		Bar.Timer = Bar:CreateFontString(nil, "OVERLAY")
		Bar.Timer:SetPoint("RIGHT", Bar, "RIGHT", -25, 0)
		Bar.Timer:SetFont(self.LSM:Fetch("font", cfg.text.font), cfg.text.fontsize, cfg.text.outline)
		Bar.Timer:SetJustifyH("RIGHT")
		Bar.Timer:SetTextColor(cfg.text.fontcolor.r, cfg.text.fontcolor.g, cfg.text.fontcolor.b)
		Bar.Timer:SetText("0")
		
		Bar:Hide()
	end

	return Bar
end

-- CreateStarsurgeCharges()
function addon:CreateStarsurgeCharges(parentFrame)
	local cfg = self.db.profile.starsurge
	
	local Starsurge = CreateFrame("Frame", nil, parentFrame)
	Starsurge:SetPoint(cfg.from, parentFrame, cfg.to, cfg.posx, cfg.posy)
	Starsurge:SetWidth(cfg.size*3)
	Starsurge:SetHeight(cfg.size)

	self.ChargeA = Starsurge:CreateTexture(nil, "LOW")
	self.ChargeA:SetPoint("TOPLEFT", Starsurge, "TOPLEFT", 0, 0)
	self.ChargeA:SetTexture("Interface\\COMMON\\Indicator-Yellow")
	self.ChargeA:SetBlendMode("BLEND")
	self.ChargeA:SetVertexColor(1, 0.69, 0.04)
	self.ChargeA:SetWidth(cfg.size)
	self.ChargeA:SetHeight(cfg.size)

	self.ChargeB = Starsurge:CreateTexture(nil, "LOW")
	self.ChargeB:SetPoint("TOPLEFT", Starsurge, "TOPLEFT", cfg.size, 0)
	self.ChargeB:SetTexture("Interface\\COMMON\\Indicator-Yellow")
	self.ChargeB:SetBlendMode("BLEND")
	self.ChargeB:SetVertexColor(1, 0.69, 0.04)
	self.ChargeB:SetWidth(cfg.size)
	self.ChargeB:SetHeight(cfg.size)

	self.ChargeC = Starsurge:CreateTexture(nil, "LOW")
	self.ChargeC:SetPoint("TOPLEFT", Starsurge, "TOPLEFT", cfg.size*2, 0)
	self.ChargeC:SetTexture("Interface\\COMMON\\Indicator-Yellow")
	self.ChargeC:SetBlendMode("BLEND")
	self.ChargeC:SetVertexColor(1, 0.69, 0.04)
	self.ChargeC:SetWidth(cfg.size)
	self.ChargeC:SetHeight(cfg.size)

	return Starsurge
end

-- CreateAuraIcon()
function addon:CreateAuraIcon(icontype, parentFrame)
  local cfg = self.db.profile.icons[icontype]
  
  local Icon = CreateFrame("Frame", nil, parentFrame)
  Icon:SetPoint(cfg.from, parentFrame, cfg.to, cfg.posx, cfg.posy)
  Icon:SetWidth(cfg.size)
  Icon:SetHeight(cfg.size)
  
  Icon.Texture = Icon:CreateTexture(nil, "LOW")
  Icon.Texture:SetAllPoints(Icon)
  Icon.Texture:SetTexture("Interface\\Icons\\"..barData.icons[icontype])
  Icon.Texture:SetTexCoord(1, 0, 0, 1)
  Icon.Texture:SetBlendMode("BLEND")
  
  Icon.Cooldown = CreateFrame("Cooldown", nil, Icon)
  Icon.Cooldown:SetAllPoints(Icon)
  
  if icontype == "solarempowerment" or icontype == "lunarempowerment" or icontype == "forceofnature" then
    Icon.Stacks = Icon:CreateFontString(nil, "OVERLAY")
    Icon.Stacks:SetPoint("TOPRIGHT", Icon, "TOPRIGHT", 4, 4)
    Icon.Stacks:SetFont(self.LSM:Fetch("font", cfg.font), cfg.fontsize, cfg.outline)
    Icon.Stacks:SetJustifyH("RIGHT")
    Icon.Stacks:SetTextColor(cfg.fontcolor.r, cfg.fontcolor.g, cfg.fontcolor.b)
	Icon.Stacks:SetText("")
  end
  
  Icon:Hide()
  return Icon
end

-------------------------------------------------------------------------------
-- ECLIPSE BAR, COOLDOWN AND AURA FUNCTIONS
-------------------------------------------------------------------------------

-- Eclipse Value Calculations
local lastSide, curSide = "Sun","Sun"
function addon:CalculateEclipseState(p)
	local cfg = self.db.profile.eclipsebar
	if p >= 0 then
		-- Solar
		curSide = "Sun"
		if curSide ~= lastSide then
			self.EclipseBar:SetStatusBarColor(cfg.solarcolor.r, cfg.solarcolor.g, cfg.solarcolor.b)
			self.EclipseBar:SetReverseFill(false)
			self.EclipseBar.EclipseLeft:SetTexture("Textures\\SpellActivationOverlays\\Eclipse_Sun")
			self.EclipseBar.EclipseLeft:SetVertexColor(cfg.solarcolor.r, cfg.solarcolor.g, cfg.solarcolor.b)
			self.EclipseBar.EclipseRight:SetTexture("Textures\\SpellActivationOverlays\\Eclipse_Sun")
			self.EclipseBar.EclipseRight:SetVertexColor(cfg.solarcolor.r, cfg.solarcolor.g, cfg.solarcolor.b)
		end
		lastSide = "Sun"
	else
		-- Lunar
		curSide = "Moon"
		if curSide ~= lastSide then
			self.EclipseBar:SetStatusBarColor(cfg.lunarcolor.r, cfg.lunarcolor.g, cfg.lunarcolor.b)
			self.EclipseBar:SetReverseFill(true)
			self.EclipseBar.EclipseLeft:SetTexture("Textures\\SpellActivationOverlays\\Eclipse_Moon")
			self.EclipseBar.EclipseLeft:SetVertexColor(cfg.lunarcolor.r, cfg.lunarcolor.g, cfg.lunarcolor.b)
			self.EclipseBar.EclipseRight:SetTexture("Textures\\SpellActivationOverlays\\Eclipse_Moon")
			self.EclipseBar.EclipseRight:SetVertexColor(cfg.lunarcolor.r, cfg.lunarcolor.g, cfg.lunarcolor.b)
		end
		lastSide = "Moon"
	end
	
	self.EclipseBar:SetValue(abs(p))
end

function addon:CalculateEclipseTime(p)
	local peakTimer
	local eclipseTimers
	local moon
	local currentPowerTime
	local extraTimer

	if GetEclipseDirection() == 'moon' then
		moon = true
	else
		moon = false
	end

	currentPowerTime = math.asin(p/105)/math.pi*20
	peakTimer = math.asin(100/105)/math.pi*20
	extraTimer =( math.asin(105/105)/math.pi*20 - peakTimer)*2

	if moon and p > 0 then
		eclipseTimers = abs(currentPowerTime)
	elseif moon and p < 0 then
		eclipseTimers = 20 - abs(currentPowerTime) - peakTimer-extraTimer
	elseif not moon and p < 0 then
		eclipseTimers = abs(currentPowerTime)
	else
		eclipseTimers = 20 - abs(currentPowerTime) - peakTimer-extraTimer
	end

	if hasEuphoria == true then
		eclipseTimers = eclipseTimers/2
	end

	self.EclipseBar.Timer:SetText(string.format("%.1f", eclipseTimers))
end

function addon:CalculateEclipseValue(p)
	self.EclipseBar.Value:SetText(abs(p))
end

local function checkDuration(bar,target,spell,curTime)
	if not spell then return end
	local name, _, _, _, _, _, duration = UnitAura(target, spell)
	local dur

	if name then
		dur = duration-curTime
		if dur <= 0 then
			bar:Hide()
		else
			bar:SetValue(string.format("%.1f", dur))
			bar.Timer:SetText(string.format("%.1f", dur))
		end
	end
end

local function checkAuraStacks(aura)
	if not aura then return end
	local name, _, _, count = UnitAura("player", aura)

	return count
end

function addon:checkStarsurgeCharges()
	local charges = GetSpellCharges(78674)
	if charges > 0 then self.ChargeA:Show() else self.ChargeA:Hide() end
	if charges > 1 then self.ChargeB:Show() else self.ChargeB:Hide() end
	if charges > 2 then self.ChargeC:Show() else self.ChargeC:Hide() end
end

-------------------------------------------------------------------------------
-- EVENT REGISTRATION
-------------------------------------------------------------------------------

function addon:OnUpdate(self, elapsed)
	local cfg = addon.db.profile
	local p = UnitPower('player',SPELL_POWER_ECLIPSE)
	local curTime = GetTime()
	local spells = barData.spells

	addon:CalculateEclipseState(p)
	addon:CalculateEclipseTime(p)
	addon:CalculateEclipseValue(p)

	if cfg.alignmentbar.enable == true then
		checkDuration(addon.AlignmentBar, "player", spells[1], curTime)
	end
	if cfg.incarnationbar.enable == true then
		checkDuration(addon.IncarnationBar, "player", spells[2], curTime)
	end
	if cfg.starfallbar.enable == true then
		checkDuration(addon.StarfallBar, "player", spells[3], curTime)
		checkDuration(addon.StarfallBar, "player", spells[4], curTime)
	end

	if cfg.starsurge.enable == true then
		addon:checkStarsurgeCharges()
	end

	if cfg.icons.solarempowerment.enable == true then
		addon.SolarEmpowerment.Stacks:SetText(checkAuraStacks(spells[5]))
	end
	if cfg.icons.lunarempowerment.enable == true then
		addon.LunarEmpowerment.Stacks:SetText(checkAuraStacks(spells[6]))
	end
end

function addon:checkCombatLog(...)
	local event, _, _, name, _, _, _, _, _, _, _, spell = ...
	local cfg = self.db.profile
	local spells = barData.spells
	local curTime = GetTime()

	if event == "SPELL_AURA_APPLIED" and name == UnitName("player") then
		if cfg.alignmentbar.enable == true and spell == spells[1] then
			self.AlignmentBar:Show()
		elseif cfg.incarnationbar.enable == true and spell == spells[2] then
			self.IncarnationBar:Show()
		elseif cfg.starfallbar.enable == true and (spell == spells[3] or spell == spells[4]) then
			self.StarfallBar:Show()
		elseif cfg.icons.solarempowerment.enable == true and spell == spells[5] then
			self.SolarEmpowerment:Show()
			self.SolarEmpowerment.Cooldown:SetCooldown(curTime, 30)
		elseif cfg.icons.lunarempowerment.enable == true and spell == spells[6] then
			self.LunarEmpowerment:Show()
			self.LunarEmpowerment.Cooldown:SetCooldown(curTime, 30)
		elseif cfg.icons.moonfire.enable == true and spell == spells[8] then
			self.Moonfire:Show()
			local dur = select(6,UnitDebuff("target", spells[8]))
			self.Moonfire.Cooldown:SetCooldown(curTime, dur or 40)
		elseif cfg.icons.sunfire.enable == true and spell == spells[9] then
			self.Sunfire:Show()
			local dur = select(6,UnitDebuff("target", spells[9]))
			self.Sunfire.Cooldown:SetCooldown(curTime, dur or 24)
		elseif cfg.icons.stellarflare.enable == true and spell == spells[10] then
			self.StellarFlare:Show()
			local dur = select(6,UnitDebuff("target", spells[10]))
			self.StellarFlare.Cooldown:SetCooldown(curTime, dur or 20)
		end

	elseif event == "SPELL_AURA_APPLIED_DOSE" and name == UnitName("player") then
		if cfg.icons.solarempowerment.enable == true and spell == spells[5] then
			self.SolarEmpowerment.Cooldown:SetCooldown(curTime, 30)
		elseif cfg.icons.lunarempowerment.enable == true and spell == spells[6] then
			self.LunarEmpowerment.Cooldown:SetCooldown(curTime, 30)
		end

	elseif event == "SPELL_AURA_REFRESH" and name == UnitName("player") then
		if cfg.icons.solarempowerment.enable == true and spell == spells[5] then
			self.SolarEmpowerment.Cooldown:SetCooldown(curTime, 30)
		elseif cfg.icons.lunarempowerment.enable == true and spell == spells[6] then
			self.LunarEmpowerment.Cooldown:SetCooldown(curTime, 30)
		elseif cfg.icons.moonfire.enable == true and spell == spells[8] then
			local dur = select(6,UnitDebuff("target", spells[8]))
			self.Moonfire:Show()
			self.Moonfire.Cooldown:SetCooldown(curTime, dur or 40)
		elseif cfg.icons.sunfire.enable == true and spell == spells[9] then
			local dur = select(6,UnitDebuff("target", spells[9]))
			self.Sunfire:Show()
			self.Sunfire.Cooldown:SetCooldown(curTime, dur or 24)
		elseif cfg.icons.stellarflare.enable == true and spell == spells[10] then
			local dur = select(6,UnitDebuff("target", spells[10]))
			self.StellarFlare:Show()
			self.StellarFlare.Cooldown:SetCooldown(curTime, dur or 20)
		end

	elseif event == "SPELL_AURA_REMOVED" and name == UnitName("player") then
		if cfg.alignmentbar.enable == true and spell == spells[1] then
			self.AlignmentBar:Hide()
		elseif cfg.incarnationbar.enable == true and spell == spells[2] then
			self.IncarnationBar:Hide()
		elseif cfg.starfallbar.enable == true and (spell == spells[3] or spell == spells[4]) then
			self.StarfallBar:Hide()
		elseif cfg.icons.solarempowerment.enable == true and spell == spells[5] then
			self.SolarEmpowerment:Hide()
		elseif cfg.icons.lunarempowerment.enable == true and spell == spells[6] then
			self.LunarEmpowerment:Hide()
		elseif cfg.icons.moonfire.enable == true and spell == spells[8] then
			self.Moonfire:Hide()
		elseif cfg.icons.sunfire.enable == true and spell == spells[9] then
			self.Sunfire:Hide()
		elseif cfg.icons.stellarflare.enable == true and spell == spells[10] then
			self.StellarFlare:Hide()
		end

	elseif event == "SPELL_CAST_SUCCESS" then
		if cfg.icons.solarempowerment.enable == true and spell == spells[11] then
			local p = UnitPower('player',SPELL_POWER_ECLIPSE)
			if p >= 0 then
				self.SolarEmpowerment.Cooldown:SetCooldown(curTime, 30)
			else
				self.LunarEmpowerment.Cooldown:SetCooldown(curTime, 30)
			end
		end
		
		if cfg.icons.moonfire.enable == true and hasBoP == true and spell == spells[12] then
			local dur = select(6,UnitDebuff("target", spells[8]))
			self.Moonfire.Cooldown:SetCooldown(curTime, dur or 40)
		elseif cfg.icons.sunfire.enable == true and hasBoP == true and spell == spells[13] then
			local dur = select(6,UnitDebuff("target", spells[8]))
			self.Sunfire.Cooldown:SetCooldown(curTime, dur or 24)
		end
	end
end

local function DebuffCheck(icon, spell)
	local name, _, _, _, _, duration, expiration = UnitDebuff("target", spell, nil, "PLAYER")
	if name then
		local start = expiration-duration
		
		icon:Show()
		icon.Cooldown:SetCooldown(start, duration)
	else
		icon:Hide()
	end
end

function addon:CheckDebuffs()
	local cfg = self.db.profile.icons
	local spells = barData.spells
	
	if cfg.moonfire.enable == true then
		DebuffCheck(self.Moonfire,spells[8])
	end
	
	if cfg.sunfire.enable == true then
		DebuffCheck(self.Sunfire,spells[9])
	end
	
	if cfg.stellarflare.enable == true then
		DebuffCheck(self.StellarFlare,spells[10])
	end
end

function addon:checkGlyphs()
	local solstice = false
	for i = 1, NUM_GLYPH_SLOTS do
		local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i);
		if glyphSpellID == 171803 then
			solstice = true
		end
		return solstice
	end
end

function addon:CheckSpecialization()
	if select(3,UnitClass("player")) == 11 and GetSpecialization() == 1 then
		local cfg = self.db.profile
		
		self.EclipseBar:Show()
		self.EclipseBar:SetScript("OnUpdate", self.OnUpdate)
		self.EclipseBar:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

		local curSpec = GetActiveSpecGroup()
		hasEuphoria = select(5,GetTalentInfo(7,1,curSpec))
		
		local curSpec = GetActiveSpecGroup()
		hasBoP = select(5,GetTalentInfo(7,3,curSpec))

		if self:checkGlyphs() == true then
			self.StarfallBar:SetStatusBarColor(cfg.starfallbar.solarcolor.r, cfg.starfallbar.solarcolor.g, cfg.starfallbar.solarcolor.b)
			self.StarfallBar:SetReverseFill(false)
			self.StarfallBar.Name:SetText("Sunfall")
		else
			self.StarfallBar:SetStatusBarColor(cfg.starfallbar.lunarcolor.r, cfg.starfallbar.lunarcolor.g, cfg.starfallbar.lunarcolor.b)
			self.StarfallBar:SetReverseFill(true)
			self.StarfallBar.Name:SetText("Starfall")
		end

		if cfg.oocfade == true then
			self.EclipseBar:RegisterEvent("PLAYER_REGEN_DISABLED")
			self.EclipseBar:RegisterEvent("PLAYER_REGEN_ENABLED")
		else
			self.EclipseBar:UnregisterEvent("PLAYER_REGEN_DISABLED")
			self.EclipseBar:UnregisterEvent("PLAYER_REGEN_ENABLED")
		end
	else
		self.EclipseBar:Hide()
		self.EclipseBar:SetScript("OnUpdate", nil)
		self.EclipseBar:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self.EclipseBar:UnregisterEvent("PLAYER_REGEN_DISABLED")
		self.EclipseBar:UnregisterEvent("PLAYER_REGEN_ENABLED")
	end
end